class AssignmentAuditSubscriber
  def self.subscribe
    ActiveSupport::Notifications.subscribe(/\Aassignment\..*/) do |*args|
      event = ActiveSupport::Notifications::Event.new(*args)
      new.handle_event(event) # Call the instance method
    end
  end

  def handle_event(event)
    action = event.name.split(".").last
    record = event.payload[:record]

    ModelVersion.create!(model: "assignment", action:, new_data: record.to_json)
  end
end
